SystemOrganization addCategory: #SqueakSVN!
SystemOrganization addCategory: #'SqueakSVN-Base'!
SystemOrganization addCategory: #'SqueakSVN-Plugins'!
SystemOrganization addCategory: #'SqueakSVN-Test'!

Object subclass: #SVNClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

SVNClient subclass: #SVNCApiClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:59'!
basicSvnAdd: pathToTarget

	<primitive: 'svnAdd' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:59'!
basicSvnCommit: collectionOfPathsToTargets
 
	<primitive: 'svnCommit' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNCApiClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:59'!
basicSvnGetHeadRevision: pathToTarget

	<primitive: 'svnGetHeadRevision' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:56'!
basicSvnAdd: aPath

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:57'!
basicSvnCommit: collectionOfPathsToTargets

	self subclassResponsibility.! !

!SVNClient methodsFor: 'svn primitives' stamp: 'rkrk 2/8/2008 00:58'!
basicSvnGetHeadRevision: pathToTarget

	self subclassResponsibility.! !

!SVNClient methodsFor: 'converting' stamp: 'rt 2/5/2008 11:32'!
normalizePath: aString 

	| modifiedPath returnPath |
	modifiedPath := aString collect: [:c | c = $\ ifTrue: [$/] ifFalse: [c]].
	(modifiedPath endsWith: '/')
		ifFalse: [returnPath := modifiedPath]
		ifTrue: 	[returnPath := modifiedPath copyFrom: 1 to: modifiedPath size - 1].
	((returnPath at: 4) = $/) ifFalse: [^returnPath].
	^(returnPath copyFrom: 1 to: 3), (returnPath copyFrom: 5 to: returnPath size).! !

!SVNClient methodsFor: 'accessing' stamp: 'rkrk 2/8/2008 00:56'!
svnAdd: aPath 

	self basicSvnAdd: (self normalizePath: aPath)! !

!SVNClient methodsFor: 'accessing' stamp: 'rkrk 2/8/2008 00:56'!
svnCommit: aCollection 

	| commitArray |
	commitArray := aCollection collect: [:each | self normalizePath: each].
	self basicSvnCommit: commitArray! !

!SVNClient methodsFor: 'accessing' stamp: 'rkrk 2/8/2008 00:55'!
svnGetHeadRevision: aPath

	^self basicSvnGetHeadRevision: (self normalizePath: aPath)! !

SVNClient subclass: #SVNCommandLineClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rkrk 2/8/2008 01:08'!
basicSvnAdd: aPath 

	self executeViaOSProcessSynchronously: 'svn add ' , aPath! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rkrk 2/8/2008 01:09'!
basicSvnCommit: collectionOfTargets 

	| targets |
	targets := collectionOfTargets inject: String new
				into: [:string :each | string , ' ' , each].
	self executeViaOSProcessSynchronously: 'svn commit' , targets , ' -m "log"'! !

!SVNCommandLineClient methodsFor: 'OSProcess' stamp: 'rkrk 2/7/2008 13:50'!
executeViaOSProcessSynchronously: command

	| p |
	self flag: #TODO. "Duplicated from SVNTestCase"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [OSProcess waitForCommand: command]
		ifTrue: [p := ExternalOSProcess command: command.
				[p isComplete] whileFalse: [(Delay forMilliseconds: 10) wait]].! !

!SVNCommandLineClient methodsFor: 'converting' stamp: 'rt 2/7/2008 10:56'!
normalizePath: aPath

	^'"' , (super normalizePath: aPath) , '"'! !

!SVNCommandLineClient methodsFor: 'svn commands' stamp: 'rkrk 2/8/2008 01:07'!
svnGetHeadRevision: aPath

	^ SVNCApiClient new svnGetHeadRevision: aPath! !

Object subclass: #SVNDummy
	instanceVariableNames: 'i1 i2'
	classVariableNames: 'C1 C2'
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

SVNDummy class
	instanceVariableNames: 'IC1 IC2'!

!SVNDummy commentStamp: '<historical>' prior: 0!
A SVNDummy is xxxxxxxxx.

Instance Variables
	i1:		<Object>
	i2:		<Object>

i1
	- xxxxx

i2
	- xxxxx
!

SVNDummy class
	instanceVariableNames: 'IC1 IC2'!

!SVNDummy class methodsFor: 'dummy' stamp: 'cop 2/7/2008 19:50'!
m3

	^ 3! !

!SVNDummy class methodsFor: 'convenience' stamp: 'cop 2/7/2008 19:50'!
sourceCodeForM2
	^ 'm2
	^ 2'! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'mu 2/12/2008 12:44'!
m1
	^ 1! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'mu 2/12/2008 12:44'!
m2
	^ 2! !

!SVNDummy methodsFor: 'dummy methods' stamp: 'cop 2/7/2008 19:50'!
methodWithSpecialCharacter: aString
	^ aString! !

Object subclass: #SVNElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

SVNElement subclass: #SVNClass
	instanceVariableNames: 'class'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNClass commentStamp: 'mu 2/7/2008 16:29' prior: 0!
A SVNClass is blablabla.

Instance Variables
	class:		<Object>

class
	- xxxxx
!

!SVNClass class methodsFor: 'as yet unclassified' stamp: 'cop 2/5/2008 10:44'!
class: aClass
	^self new
		class: aClass;
		yourself.! !

!SVNClass methodsFor: 'accessing' stamp: 'cop 2/5/2008 09:50'!
class: aClass
	class := aClass! !

!SVNClass methodsFor: 'write' stamp: 'mu 2/5/2008 13:41'!
contentsForFile
	^'Instance side', String cr,
	self getClass superclass name, String cr,
		self getClass category, String cr,
		(self createStringFromCollection: self getClass instVarNames), String cr,
		(self createStringFromCollection: self getClass classVarNames), String cr,
		(self createStringFromCollection: self getClass poolDictionaryNames), String cr,
		'Class side', String cr,
		(self createStringFromCollection: self getClass classSide instVarNames)! !

!SVNClass methodsFor: 'support' stamp: 'mu 2/7/2008 16:42'!
createClass: aClass withContents: contents 
	^ class := (self extractSuperclassFrom: contents)
				subclass: aClass asSymbol
				instanceVariableNames: (self extractInstVarsFrom: contents)
				classVariableNames: (self extractClassVarsFrom: contents)
				poolDictionaries: (self extractPoolDictFrom: contents)
				category: (self extractCategoryFrom: contents)! !

!SVNClass methodsFor: 'extracting' stamp: 'mu 2/7/2008 13:58'!
extractCategoryFrom: contents
	
	^ contents lineNumber: 3.! !

!SVNClass methodsFor: 'extracting' stamp: 'mu 2/7/2008 14:49'!
extractClassVarsFrom: contents
	
	^ contents lineNumber: 5! !

!SVNClass methodsFor: 'extracting' stamp: 'mu 2/7/2008 14:50'!
extractInstVarsFrom: contents
	
	^ contents lineNumber: 4.! !

!SVNClass methodsFor: 'extracting' stamp: 'mu 2/7/2008 14:53'!
extractMetaInstVarsFrom: contents
	
	^ contents lineNumber: 8! !

!SVNClass methodsFor: 'extracting' stamp: 'mu 2/7/2008 14:53'!
extractPoolDictFrom: contents
	
	^ contents lineNumber: 6! !

!SVNClass methodsFor: 'extracting' stamp: 'mu 2/7/2008 14:00'!
extractSuperclassFrom: contents
	
	^ self lookForClass: (contents lineNumber: 2)! !

!SVNClass methodsFor: 'accessing' stamp: 'mu 2/5/2008 13:36'!
getClass
	^class! !

!SVNClass methodsFor: 'support' stamp: 'rkrk 2/8/2008 01:25'!
lookForClass: aString

	self flag: #BeCareful. "^ SystemDictionary new classNamed: aString"
	Smalltalk classNamed: aString.
	! !

!SVNClass methodsFor: 'read' stamp: 'mu 2/7/2008 16:26'!
readCommentFrom: aPath

	class comment: (self contentsOfFileNamed: aPath, FileDirectory slash, 'comment').! !

!SVNClass methodsFor: 'read' stamp: 'cop 2/12/2008 11:55'!
readElementFrom: aPath
	| className contents |
	className := (FileDirectory on: aPath) localName.
	contents := self readFilePropertiesFrom: aPath.
	self
		createClass: className withContents: contents;
		readCommentFrom: aPath;
		readMethodsFrom: aPath , FileDirectory slash , 'instance' for: class;
		readMethodsFrom: aPath , FileDirectory slash , 'class' for: class classSide! !

!SVNClass methodsFor: 'read' stamp: 'cop 2/12/2008 11:53'!
readElementFrom: aPath for: anObject 
	| className contents |
	className := (FileDirectory on: aPath) localName.
	contents := self readFilePropertiesFrom: aPath.
	self
		createClass: className withContents: contents;
		readCommentFrom: aPath;
		readMethodsFrom: aPath , FileDirectory slash , 'instance' for: nil;
		readMethodsFrom: aPath , FileDirectory slash , 'class' for: nil! !

!SVNClass methodsFor: 'read' stamp: 'mu 2/7/2008 16:28'!
readFilePropertiesFrom: aPath 
	^ self contentsOfFileNamed: aPath , FileDirectory slash , 'properties'! !

!SVNClass methodsFor: 'read' stamp: 'cop 2/12/2008 11:53'!
readMethodsFrom: aPath for: anObject 
	(FileDirectory on: aPath) fileNames 
		do: [:each | SVNMethod readElementFrom: aPath , FileDirectory slash , each for: class]! !

!SVNClass methodsFor: 'write' stamp: 'mu 2/5/2008 13:39'!
writeClassMethods: aPath
	| path |
	path := aPath, 'class', FileDirectory slash.
	(FileDirectory on: path) assureExistence.
	self writeMethods: self getClass classSide methodDictionary to: path.! !

!SVNClass methodsFor: 'write' stamp: 'mu 2/5/2008 13:39'!
writeCommentTo: aPath
	self write: self getClass comment to: aPath, FileDirectory slash, 'comment'! !

!SVNClass methodsFor: 'write' stamp: 'mu 2/11/2008 15:09'!
writeElementTo: aPath
	| path |
	path := aPath, FileDirectory slash, self getClass name, FileDirectory slash.
	(FileDirectory on: path) assureExistence.
	self
		writeClassMethods: path;
		writeInstanceMethods: path;
		writeCommentTo: path;
		writePropertiesTo: path.! !

!SVNClass methodsFor: 'write' stamp: 'mu 2/5/2008 13:38'!
writeInstanceMethods: aPath
	| path |
	path := aPath, 'instance', FileDirectory slash.
	(FileDirectory on: path) assureExistence.
	self writeMethods: self getClass methodDictionary to: path.! !

!SVNClass methodsFor: 'write' stamp: 'mu 2/5/2008 13:32'!
writeMethods: aMethDict to: aPath
	
	aMethDict do: [ :each | (SVNMethod for: each)
		writeElementTo: aPath].! !

!SVNClass methodsFor: 'write' stamp: 'cop 2/5/2008 11:19'!
writePropertiesTo: aPath
	self write: self contentsForFile to: aPath, FileDirectory slash, 'properties'! !

!SVNElement class methodsFor: 'instance creation' stamp: 'cop 2/12/2008 11:59'!
readElementFrom: aPath for: aClass
	^ (self new)
		readElementFrom: aPath for: aClass;
		yourself! !

!SVNElement methodsFor: 'read' stamp: 'mu 2/7/2008 13:54'!
contentsOfFileNamed: pathToFile

	^ (FileStream readOnlyFileNamed: pathToFile) contents.! !

!SVNElement methodsFor: 'write' stamp: 'rkrk 2/8/2008 01:22'!
createStringFromCollection: aCol

	^ String streamContents: [:s | aCol asStringOn: s delimiter: ' ']! !

!SVNElement methodsFor: 'write' stamp: 'cop 2/12/2008 11:50'!
readElementFrom: aPath for: anObject 
	self subclassResponsibility! !

!SVNElement methodsFor: 'write' stamp: 'rkrk 2/8/2008 01:22'!
write: aString to: aPath

	(FileStream forceNewFileNamed: aPath )
		nextPutAll: aString;
		close.! !

!SVNElement methodsFor: 'write' stamp: 'rkrk 2/8/2008 01:22'!
writeElementTo: aPath

	self subclassResponsibility.! !

SVNElement subclass: #SVNMethod
	instanceVariableNames: 'methodReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNMethod class methodsFor: 'instance creation' stamp: 'rkrk 2/1/2008 02:20'!
for: aCompiledMethod 
	
	^ self methodReference: aCompiledMethod methodReference.! !

!SVNMethod class methodsFor: 'instance creation' stamp: 'rkrk 1/6/2008 21:38'!
methodReference: aMethodReference 
	
	^ self new
		methodReference: aMethodReference;
		yourself! !

!SVNMethod methodsFor: 'comparing' stamp: 'rkrk 1/6/2008 22:07'!
= otherMethod

	self species = otherMethod species ifFalse: [^ false].
	^ self methodClass = otherMethod methodClass &
			(self methodReference = otherMethod methodReference).! !

!SVNMethod methodsFor: 'modifying system' stamp: 'test 2/12/2008 12:02'!
compileMethodFrom: contents for: aClass
	| sourceCode selector |
	sourceCode := self extractSourceCodeFrom: contents.
	selector := aClass compile: sourceCode.
	^ aClass >> selector! !

!SVNMethod methodsFor: 'serializing' stamp: 'cop 2/12/2008 11:42'!
contentsForFile
	
	"Mapping method to contents of a file"
	self flag: #TODO.
	
	"For now: save the name of the category in the first line. The source code below."
	^ self methodReference category , String cr , self methodReference source! !

!SVNMethod methodsFor: 'read' stamp: 'cop 2/12/2008 11:42'!
extractCategoryFrom: contents

	^ contents lineNumber: 1! !

!SVNMethod methodsFor: 'read' stamp: 'rkrk 2/1/2008 23:23'!
extractClassFrom: contents

	| classStrings theClass |
	classStrings := (contents lineNumber: 1) substrings.
	theClass := Smalltalk at: classStrings first asSymbol.
	^ (classStrings last = 'class')
		ifTrue: [theClass class]
		ifFalse: [theClass].! !

!SVNMethod methodsFor: 'read' stamp: 'test 2/12/2008 12:06'!
extractSourceCodeFrom: aString 
	"Do not read the first line, it's the protocol"
	^ aString
		copyFrom: ( aString indexOf: Character cr ) + 1
		to: aString size! !

!SVNMethod methodsFor: 'read' stamp: 'cop 2/1/2008 17:51'!
extractTimeStampFrom: contents

	^ Smalltalk at: (contents lineNumber: 1) asSymbol! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'mu 2/7/2008 12:57'!
fileName

	| methodName |
	methodName := self selector asString.
	methodName replaceAll: $: with: $#.
	^ methodName! !

!SVNMethod methodsFor: 'comparing' stamp: 'rkrk 2/1/2008 11:38'!
hash

	^ self methodReference hash! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'rkrk 1/6/2008 21:41'!
methodClass
	
	^ self methodReference actualClass! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 21:41'!
methodReference
	
	 ^ methodReference! !

!SVNMethod methodsFor: 'accessing' stamp: 'rkrk 2/1/2008 02:59'!
methodReference: aMethodReference 
	
	methodReference := aMethodReference.! !

!SVNMethod methodsFor: 'comparing' stamp: 'rkrk 2/1/2008 11:24'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: $(.
	self methodReference printOn: aStream.
	aStream nextPut: $).! !

!SVNMethod methodsFor: 'read' stamp: 'cop 2/12/2008 11:51'!
readElementFrom: aPath for: aClass
	| contents organization |
	contents := self contentsOfFileNamed: aPath.
	methodReference := (self compileMethodFrom: contents for: aClass) 
				methodReference.
	organization := aClass organization.
	organization classify: self selector
		under: (self extractCategoryFrom: contents)! !

!SVNMethod methodsFor: 'derived accessing' stamp: 'rkrk 2/1/2008 02:58'!
selector

	^ self methodReference methodSymbol! !

!SVNMethod methodsFor: 'write' stamp: 'cop 2/5/2008 11:09'!
writeElementTo: aPath
	self write: self contentsForFile to: aPath , FileDirectory slash , self fileName.! !

SVNElement subclass: #SVNProject
	instanceVariableNames: 'versionedClasses versionedMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Base'!

!SVNProject methodsFor: 'adding' stamp: 'rkrk 1/6/2008 21:31'!
addClass: aClass

	self versionedClasses add: aClass! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 2/2/2008 19:22'!
addMethod: aMethod 
	
	^ self versionedMethods add: (SVNMethod for: aMethod)! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 2/2/2008 19:26'!
allVersionedMethods
	
	| methodsOfClasses |
	methodsOfClasses := self versionedClasses gather: [:eachClass |
		eachClass methodDict collect: [:eachMethod | SVNMethod for: eachMethod]].
	^ self versionedMethods union: methodsOfClasses! !

!SVNProject methodsFor: 'adding' stamp: 'rkrk 1/6/2008 21:31'!
initialize

	super initialize.
	versionedClasses := Set new.
	versionedMethods := Set new.! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 1/6/2008 21:31'!
versionedClasses
	
	^ versionedClasses ! !

!SVNProject methodsFor: 'accessing' stamp: 'rkrk 2/2/2008 19:25'!
versionedMethods
	
	^ versionedMethods! !

Object subclass: #SqueakSVNPluginCaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

!SqueakSVNPluginCaller commentStamp: 'rkrk 1/7/2008 02:27' prior: 0!
Only for testing purposes!!!

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 1/31/2008 05:20'!
answer17

	<primitive: 'answerSeventeen' module: 'PluginAnswering17'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 1/4/2008 16:58'!
callStringTest01

	<primitive: 'stringTest01' module: 'SqueakSVNPlugin'>
	^nil! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 2/6/2008 16:27'!
primSvnGetHeadRevision: target

	<primitive: 'svnGetHeadRevision' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

!SqueakSVNPluginCaller class methodsFor: 'as yet unclassified' stamp: 'rkrk 2/6/2008 16:29'!
primSvnModifiedAdd: target

	<primitive: 'svnModifiedAdd' module: 'SqueakSVNPlugin'>
	self primitiveFailed! !

TestCase subclass: #SVNTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

SVNTestCase subclass: #SVNClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

!SVNClassTest methodsFor: 'helper' stamp: 'cop 2/12/2008 11:32'!
allMethodNamesOfClass: aClass 
	^ aClass methodDict collect: [:each | (SVNMethod for: each) fileName]! !

!SVNClassTest methodsFor: 'helper' stamp: 'mu 2/11/2008 15:54'!
assertThatFiles: fileNames existsIn: path

	fileNames  do: [:each | self assert: ((FileDirectory on: path) fileExists: each)] .! !

!SVNClassTest methodsFor: 'helper' stamp: 'mu 2/12/2008 01:36'!
expectedPropertiesFile
	^ 'Instance side
Object
SqueakSVN-Test
i1 i2
C1 C2

Class side
IC1 IC2'! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 2/12/2008 12:42'!
prepareTest
	| class path |
	class := SVNClass class: SVNDummy.
	path := self pathForTests , FileDirectory slash , class getClass name.
	self ensureThatFileNotExist: path.
	class writeElementTo: self pathForTests.
	^ path! !

!SVNClassTest methodsFor: 'tests' stamp: 'cop 2/12/2008 11:32'!
testAllClassMethodsExists
	| path |
	path := self pathForTests , FileDirectory slash , 'SVNDummy' 
				, FileDirectory slash , 'class'.
	self ensureThatFileNotExist: path.
	(SVNClass class: SVNDummy) writeElementTo: self pathForTests.
	self assertThatFiles: (self allMethodNamesOfClass: SVNDummy class)
		existsIn: path! !

!SVNClassTest methodsFor: 'tests' stamp: 'cop 2/12/2008 11:32'!
testAllInstanceMethodsExists
	| path |
	path := self pathForTests , FileDirectory slash , 'SVNDummy' 
				, FileDirectory slash , 'instance'.
	self ensureThatFileNotExist: path.
	(SVNClass class: SVNDummy) writeElementTo: self pathForTests.
	self assertThatFiles: (self allMethodNamesOfClass: SVNDummy) existsIn: path! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 2/12/2008 12:43'!
testWriteCommentFile
	| path commentContent |
	path := self prepareTest.
	commentContent := (FileStream readOnlyFileNamed: path , FileDirectory slash , 'comment') contentsOfEntireFile.
	self assert: ((FileDirectory on: path) fileExists: 'comment').
	self assert: SVNDummy comment = commentContent! !

!SVNClassTest methodsFor: 'tests' stamp: 'mu 2/12/2008 12:44'!
testWritePropertiesFile
	| path propertiesContent |
	path := self prepareTest.
	propertiesContent := (FileStream readOnlyFileNamed: path , FileDirectory slash , 'properties') contentsOfEntireFile.
	self assert: ((FileDirectory on: path) fileExists: 'properties').
	self assert: self expectedPropertiesFile = propertiesContent! !

SVNTestCase subclass: #SVNClientTest
	instanceVariableNames: 'repositoryPath workingCopyPath fileToAdd sut'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

SVNClientTest subclass: #SVNClientExternalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

SVNClientExternalTest subclass: #SVNCApiClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

!SVNCApiClientTest methodsFor: 'running' stamp: 'rkrk 2/7/2008 15:46'!
setUp

	super setUp.
	sut := SVNCApiClient new.! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 2/8/2008 00:54'!
testGetHeadRevision

	self assert: (sut svnGetHeadRevision: workingCopyPath) = 0. ! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:42'!
testSVNAdd

	| path |
	path := workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	self assertWorkingCopyIncludesFile: fileToAdd.! !

!SVNCApiClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:42'!
testSvnCommit

	| path startRevision endRevision |
	path := workingCopyPath.
	sut svnAdd: path , self slash , fileToAdd.
	startRevision := sut svnGetHeadRevision: path.

	sut svnCommit: (Array with: path , self slash , fileToAdd).

	endRevision := sut svnGetHeadRevision: path.
	self assert: startRevision + 1 = endRevision! !

!SVNClientExternalTest methodsFor: 'assert' stamp: 'rkrk 2/7/2008 15:44'!
assertWorkingCopyIncludesFile: fileName

	| svnDir wcEntries wcEntriesContents |
	self flag: #Todo. "Kludge. Better to use Svn Api to check if file was added."
	svnDir := FileDirectory on: workingCopyPath , FileDirectory slash , '.svn'.
	wcEntries := svnDir readOnlyFileNamed: 'entries'.
	wcEntriesContents := wcEntries contents.
	wcEntries close.
	self assert: (wcEntriesContents includesSubString: fileName).! !

!SVNClientExternalTest methodsFor: 'helper' stamp: 'rkrk 2/7/2008 15:45'!
createFile: fullPathOfFile

	(FileStream newFileNamed: fullPathOfFile) close.! !

!SVNClientExternalTest methodsFor: 'helper' stamp: 'rkrk 2/7/2008 15:45'!
createRepository
	
	self assert: (FileDirectory isLegalFileName: repositoryPath).
	self deny: (FileDirectory on: repositoryPath , self slash) exists.
	
	self executeViaOSProcessSynchronously: 'svnadmin create ' , repositoryPath.! !

!SVNClientExternalTest methodsFor: 'helper' stamp: 'rkrk 2/7/2008 15:45'!
createWorkingCopy

	| repositoryURLPath |
	self assert: (FileDirectory on: repositoryPath , self slash) exists.
	self deny: (FileDirectory on: workingCopyPath) exists.
	
	repositoryURLPath := (FileDirectory urlForFileNamed: repositoryPath) asString.
	self executeViaOSProcessSynchronously: 'svn co ' , repositoryURLPath , ' ' , workingCopyPath! !

!SVNClientExternalTest methodsFor: 'running' stamp: 'rkrk 2/7/2008 15:44'!
setUp

	super setUp.
	repositoryPath := self pathForTests , self slash , 'repository'.
	workingCopyPath := self pathForTests , self slash , 'workingCopy'.
	self
		createRepository;
		createWorkingCopy.
	fileToAdd := 'testFile'.
	self createFile: workingCopyPath , self slash , 'testFile'.! !

SVNClientExternalTest subclass: #SVNCommandLineClientTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

!SVNCommandLineClientTest methodsFor: 'running' stamp: 'rkrk 2/7/2008 15:41'!
setUp

	super setUp.
	sut := SVNCommandLineClient new.! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:41'!
testSVNAdd

	| path |
	path := workingCopyPath , self slash , fileToAdd.
	sut svnAdd: path.
	self assertWorkingCopyIncludesFile: fileToAdd.! !

!SVNCommandLineClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:41'!
testSvnCommit

	| path startRevision endRevision |
	path := workingCopyPath.
	sut svnAdd: path , self slash , fileToAdd.
	startRevision := sut svnGetHeadRevision: path.

	sut svnCommit: (Array with: path , self slash , fileToAdd).

	endRevision := sut svnGetHeadRevision: path.
	self assert: startRevision + 1 = endRevision! !

!SVNClientTest methodsFor: 'running' stamp: 'rkrk 2/7/2008 15:44'!
setUp
	"self halt."

	super setUp.
	sut := SVNCApiClient new.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rt 2/5/2008 10:54'!
testBackslashToSlash

	| validPath |
	validPath := sut normalizePath: 'C:\test\test'.
	self	assert: validPath = 'C:/test/test'.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rkrk 2/7/2008 15:43'!
testCommandLineNormalizePathInsertsQuotationMarks

	| string expected result |
	sut := SVNCommandLineClient new.
	string := 'blabla/blabla'.
	expected := '"' , string , '"'.
	result := sut normalizePath: string.
	self assert: expected = result.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rt 2/5/2008 11:17'!
testRemoveDoubbleBackslash

	| validPath |
	validPath := sut normalizePath: 'C:\\test\test'.
	self	assert: validPath = 'C:/test/test'.! !

!SVNClientTest methodsFor: 'tests' stamp: 'rt 2/5/2008 10:59'!
testRemoveLastSlash

	| path |
	path := sut normalizePath: 'C:\test\test\'.
	self assert: path = 'C:/test/test'.! !

SVNTestCase subclass: #SVNMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

!SVNMethodTest methodsFor: 'test support' stamp: 'rkrk 2/1/2008 04:12'!
inFile: pathToFile write: aString

	(FileStream forceNewFileNamed: pathToFile)
		nextPutAll: aString;
		close.

	! !

!SVNMethodTest methodsFor: 'running' stamp: 'mu 2/7/2008 16:57'!
tearDown
	super tearDown.
	SVNDummy methodDict
		at: #m2
		ifAbsent: [SVNDummy compile: SVNDummy sourceCodeForM2]! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'test 2/12/2008 12:07'!
testContentsToWrite
	| method expected result |
	method := SVNMethod for: SVNDummy >> #m1.
	expected := 'dummy methods
m1
	^ 1'.
	result := method contentsForFile.
	self assert: expected = result! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'cop 2/12/2008 11:57'!
testContentsToWriteCaseMetaClass
	| method expected result |
	method := SVNMethod for: SVNDummy class >> #m3.
	expected := 'dummy
m3

	^ 3'.
	result := method contentsForFile.
	self assert: expected = result! !

!SVNMethodTest methodsFor: 'tests' stamp: 'mu 2/7/2008 16:55'!
testEquals
	| methodBlock method1 method2 |
	methodBlock := 
	[ SVNMethod methodReference: (SVNDummy >> #m1) methodReference ].
	method1 := methodBlock value.
	method2 := methodBlock value.
	self assert: method1 ~~ method2.
	self assert: method1 = method2! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'mu 2/7/2008 16:54'!
testExtractMetaClass
	| source method result expected |
	method := SVNMethod new.
	source := 'SVNDummy class' , String cr , 'dummy' , String cr , 'm4 ^ 4'.
	result := method extractClassFrom: source.
	expected := SVNDummy class.
	self assert: result = expected! !

!SVNMethodTest methodsFor: 'tests read' stamp: 'test 2/12/2008 12:06'!
testRead
	| method expectedSource methodName fileName |
	methodName := 'm2'.
	expectedSource := 'dummy methods' , String cr 
				, SVNDummy sourceCodeForM2.
	SVNDummy removeSelector: methodName asSymbol.
	fileName := self pathForTests , FileDirectory slash , methodName.
	self inFile: fileName write: expectedSource.
	method := SVNMethod readElementFrom: fileName for: SVNDummy.
	self assert: expectedSource = method contentsForFile! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'test 2/12/2008 12:07'!
testWrite
	| method contents expected fileName |
	method := SVNMethod for: SVNDummy >> #methodWithSpecialCharacter:.
	fileName := self pathForTests , FileDirectory slash , method fileName.
	self ensureThatFileNotExist: fileName.
	method writeElementTo: self pathForTests.
	contents := (FileStream readOnlyFileNamed: fileName) contentsOfEntireFile.
	expected := 'dummy methods
methodWithSpecialCharacter: aString
	^ aString'.
	self assert: expected = contents.
	self ensureThatFileNotExist: fileName! !

!SVNMethodTest methodsFor: 'tests write' stamp: 'cop 2/12/2008 11:58'!
testWriteRead
	| method fileName readMethod |
	method := SVNMethod for: SVNDummy >> #m1.
	fileName := self createPathToFile: method fileName
				inDirectory: self pathForTests.
	self ensureThatFileNotExist: fileName.
	method writeElementTo: self pathForTests.
	readMethod := SVNMethod readElementFrom: fileName for: SVNDummy.
	self assert: method = readMethod.
	self ensureThatFileNotExist: fileName! !

SVNTestCase subclass: #SVNProjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVN-Test'!

!SVNProjectTest methodsFor: 'tests' stamp: 'mu 2/7/2008 16:56'!
testAddClass
	| sut aClass methodsOfClass result |
	sut := SVNProject new.
	aClass := SVNDummy.
	sut addClass: aClass.
	self assert: (sut versionedClasses includes: aClass).
	methodsOfClass := aClass methodDict collect: [ : ea | SVNMethod for: ea ].
	result := sut allVersionedMethods asSet.
	self assert: result = methodsOfClass asSet! !

!SVNProjectTest methodsFor: 'tests' stamp: 'mu 2/7/2008 16:56'!
testAddMethod
	| sut aMethod svnMethod |
	sut := SVNProject new.
	aMethod := SVNDummy >> #m1.
	sut addMethod: aMethod.
	self assert: sut versionedMethods size = 1.
	svnMethod := sut versionedMethods someElement.
	self assert: svnMethod methodClass = aMethod methodClass.
	self assert: svnMethod selector = aMethod selector! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/1/2008 15:34'!
createPathToFile: filename inDirectory: pathToDirectory

	^ pathToDirectory , self slash , filename! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/1/2008 15:30'!
ensureThatFileNotExist: fileName

	FileDirectory deleteFilePath: fileName! !

!SVNTestCase methodsFor: 'OSProcess' stamp: 'rkrk 2/7/2008 13:51'!
executeViaOSProcessSynchronously: command

	| p |
	self flag: #TODO. "Encapsulate plattform dependence. Subclass? Strategy?"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [OSProcess waitForCommand: command]
		ifTrue: [p := ExternalOSProcess command: command.
				[p isComplete] whileFalse: [(Delay forMilliseconds: 10) wait]].! !

!SVNTestCase methodsFor: 'test support' stamp: 'cop 2/12/2008 11:24'!
pathForTests

	"If you touch the path, reset it before commit!!'"
	^ SmalltalkImage current imagePath , FileDirectory slash , 'svnTests'! !

!SVNTestCase methodsFor: 'test support' stamp: 'cop 2/5/2008 11:33'!
readFileFrom: aDir fileName: aString

	| stream contents |
	stream := aDir oldFileNamed: aString.
	contents := stream contents.
	stream close.
	^contents! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 2/1/2008 15:39'!
setUp

	super setUp.
	(FileDirectory on: self pathForTests) assureExistence.! !

!SVNTestCase methodsFor: 'helper' stamp: 'rkrk 2/1/2008 15:24'!
slash

	^ FileDirectory slash! !

!SVNTestCase methodsFor: 'running' stamp: 'rkrk 2/3/2008 22:43'!
tearDown

	super tearDown.
	self flag: #TODO. "Encapsulate plattform dependence. Subclass? Strategy?"
	SmalltalkImage current platformName =  'Win32'
		ifFalse: [(FileDirectory on: self pathForTests) recursiveDelete]
		ifTrue: [self executeViaOSProcessSynchronously: 'delete_svnTests.bat'].! !
